论坛风格切换切换到宽版
 
  • 帖子
  • 文章
  • 日志
  • 用户
  • 版块
  • 群组
帖子
  • 2530阅读
  • 12回复

[【求助】]Tekla二次开发的具体问题:没有Rotate方法,怎么旋转? [复制链接]

上一主题 下一主题
离线shawnxiao
 

发帖
20
金币
36
威望
3
贡献值
0
怪怪币
0
只看楼主 倒序阅读 楼主  发表于: 2015-09-16
奇奇怪论坛Tekla详图1群=>     
奇奇怪论坛Tekla详图2群=>
奇奇怪论坛Tekla插件2群=>SSBIM for Tekla插件2群     
奇奇怪论坛Revit   钢构群=>

Tekla Structures 软件各版本下载【2019/10/09更新至Tekla2019i】


如题,在"Tekla.Structures.Operations",只有"CopyObject"和"MoveObject",没有"Rotate"(也没有"Mirror")。
"MoveObject"方法只有两种执行方式:
1、MoveObject(ModelObject, Vector),
参数是被移动对象和方向;
2、MoveObject(ModelObject, CoordinateSystem, CoordinateSystem),
参数是被移动对象和源坐标系、目标坐标系。

现在我要旋转一个零件,就只能采用Move的第二种方式。
就是要定义两个坐标系,在坐标系间移动。
定义坐标系只有两种方式:
1、CoordinateSystem()
关于它的描述是"Instantiates a coordinate system in the XY-plane. "
如何在XY平面实例化一个坐标系,我还没整明白。
2、CoordinateSystem(Point, Vector, Vector)
这个好理解,参数是原点和X、Y方向。

这样旋转零件实在是很头疼的事情,有没有别的方法?
离线ahwx0814

发帖
117
金币
1562
威望
94
贡献值
0
怪怪币
0
只看该作者 沙发  发表于: 2015-09-16
旋转,就是坐标系的旋转,设置好坐标系就可以旋转了
离线mmkkgg2010

发帖
9310
金币
916
威望
303
贡献值
0
怪怪币
0
只看该作者 板凳  发表于: 2015-09-16
        
离线shawnxiao

发帖
20
金币
36
威望
3
贡献值
0
怪怪币
0
只看该作者 地板  发表于: 2015-09-16
就是觉得设置坐标系太麻烦
离线djxiu

发帖
14
金币
2
威望
0
贡献值
0
怪怪币
0
只看该作者 4楼 发表于: 2015-09-18
you can try
Tekla.Structures.Geometry3d     MatrixFactory.Rotate Method
离线colincy1

发帖
3
金币
16
威望
21
贡献值
0
怪怪币
0
只看该作者 5楼 发表于: 2015-09-21
回 djxiu 的帖子
djxiu:you can try Tekla.Structures.Geometry3d     MatrixFactory.Rotate Method (2015-09-18 14:45) 

我也试试,正头疼
离线suofeiy

发帖
34
金币
86
威望
22
贡献值
0
怪怪币
0
只看该作者 6楼 发表于: 2015-10-08
录制一个宏,然后通过程序调用这个宏,有没有方便点,但是这种方法也有一定的局限性,旋转的角度必须先自己输好
离线mhztc

发帖
67
金币
435
威望
29
贡献值
0
怪怪币
0
只看该作者 7楼 发表于: 2015-10-09
你可以自己写一个函数,根据自己的参数来旋转对象。这样下一次就方便了。
离线a122126287

发帖
46
金币
48
威望
32
贡献值
0
怪怪币
0
只看该作者 8楼 发表于: 2015-10-18
内容直接自己封装一个旋转的方法,存到自己的类库当中去,以后要用直接调用。另外找一个tekla二次开发的群,Qq上找的群净是些乱七八糟的群,整天聊些乱七八糟的东西。
离线a122126287

发帖
46
金币
48
威望
32
贡献值
0
怪怪币
0
只看该作者 9楼 发表于: 2015-10-18
封装内容可以写以原点为中心指定旋转角度,或者再写个重载以原点为中心指定相对旋转位置,通过三角函数求出旋转角度。
离线slz

发帖
4240
金币
388
威望
500
贡献值
0
怪怪币
0
只看该作者 10楼 发表于: 2015-12-08
      
离线slz

发帖
4240
金币
388
威望
500
贡献值
0
怪怪币
0
只看该作者 11楼 发表于: 2016-04-09
          
离线slz

发帖
4240
金币
388
威望
500
贡献值
0
怪怪币
0
只看该作者 12楼 发表于: 2019-12-24
旋转,就是坐标系的旋转,设置好坐标系就可以旋转了